Program CPConv;

{  Simple program for OS/2 and eComStation that converts textfiles
   from one CodePage to another. (c) Slawomir Stachniewicz, 2001  }

uses    os2def,os2pmapi;

const   BufLength=32768;

var     fileIN,fileOUT:file;
        cpIN,cpOUT:ULong;
        AB:Hab;
        rc:Bool;
        code,i:longint;
        ch:char;
        table:array[0..255] of char;
        buffer:array[0..BufLength-1] of char;

procedure errormsg;
begin
 writeln;
 writeln('   Usage: CPCONV codepage_IN codepage_OUT file_IN file_OUT');
 writeln;
 writeln('   codepage_{IN,OUT} must be CodePage numbers recognized by OS/2');
 halt;
end;

{
procedure errorcp(msg:string);
begin
 writeln;
 writeln('   Error in WinCpTranslateChar - ',msg,'!'#7);
 halt;
end;
}

begin
 if paramcount<4 then errormsg;
 val(paramstr(1),cpIN,code);
 if code<>0 then errormsg;
 val(paramstr(2),cpOUT,code);
 if code<>0 then errormsg;
 AB:=WinInitialize(0);
 for i:=0 to 127 do table[i]:=chr(lo(i));
 for i:=128 to 255 do
 begin
  ch:=WinCpTranslateChar(AB,cpIN,chr(lo(i)),cpOUT);
{  if ch=#0 then
  begin
   code:=WinGetLastError(AB);
   case code of
    $100B: errorcp('invalid character');
    $101D: errorcp('invalid source codepage');
    $101E: errorcp('invalid dest. codepage')
   end;
  end;}
  table[i]:=ch;
 end;

 filemode:=0;
 assign(fileIN,paramstr(3));
 reset(fileIN,1);
 assign(fileOUT,paramstr(4));
 rewrite(fileOUT,1);

 while not eof(fileIN) do
 begin
  BlockRead(fileIN,buffer,BufLength,i);
  asm
   mov ecx, i
   lea esi, buffer
   mov edi, esi
   cld
@loop:
   xor eax, eax
   lodsb
   mov ebx, eax
   mov al, byte ptr ds:table[ebx]
   segds stosb
   loop @loop
  end;
  BlockWrite(fileOUT,buffer,i,i);
 end;

 close(fileIN);
 close(fileOUT);
end.
